<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once(BASEDIR."side_left.php");

if(!iMEMBER) {
	fallback("index.php");
}
require_once("include/common.php");


// count running games only
function count_games($user_id)
{
	return dbcount("(*)", "aw_chess",
		"(owner_id='$user_id'"
			." AND (state='".AW_RUNNING."'"
				." OR state='".CHESS_REQUEST."'))");
}

function awc_user_can_play($id)
{
	global $awc_settings;
	if(iSUPERADMIN) {
		return true;
	}

	$query_id = dbquery("SELECT user_groups, user_level"
		." FROM ".DB_PREFIX."users"
		." WHERE user_id='$id'");
	if(!dbrows($query_id)) {
		return false;
	}
	$data = dbarray($query_id);
	if($awc_settings['player_group'] < 101) {// FIXME
		return in_array($awc_settings['player_group'],
			explode(".", $data['user_groups']));
	}
	return $data['user_level'] >= $awc_settings['player_group'];
}

/*
 * ACTION
 */
/* CREATE NEW GAME */
if(iMEMBER && isset($_POST['invite'])) {
	$inviter_id = $userdata['user_id'];
	$opp_id = stripinput($_POST['opp_id']);
	$opp_is_white = isset($_POST['aw_opp_white']);
	$is_public = isset($_POST['aw_is_public']);

	if(!awc_user_can_play($inviter_id)) {
		fallback(FUSION_SELF);
	}
	if(!awc_user_can_play($opp_id)) {
		fallback(FUSION_SELF);
	}
	if(count_games($inviter_id) >= AW_MAX_GAMES) {
		fallback(FUSION_SELF);
	}

	if($opp_is_white) {
		$white_id = $opp_id;
		$black_id = $inviter_id;
	} else {
		$white_id = $inviter_id;
		$black_id = $opp_id;
	}
	$is_public = ($is_public ? "Y" : "N");

	// insert
	$ok = dbquery("INSERT INTO ".DB_PREFIX."aw_chess"
		." SET"
		." owner_id='$inviter_id',"
		." white_id='$white_id',"
		." black_id='$black_id',"
		." white_next='Y',"
		." ctime='".time()."',"
		." public='$is_public',"
		." board='".AWC_BOARD."'");
	if(!$ok) {
		fallback(FUSION_SELF);
	}
	$new_id = mysql_insert_id();
	awc_send_pm($inviter_id, $opp_id, $locale['AWC013'],
		$locale['AWC104']
		."<br><br>[url=".$settings['siteurl']
			."infusions/aw_chess/viewgame.php?id=$new_id"
			."]".$locale['AWC020']."[/url]");
	fallback("viewgame.php?id=$new_id");
}


// GUI
opentable($locale['AWC013']);
awc_show_menu();

if(!awc_user_can_play($userdata['user_id'])) {
	echo "<p>".$locale['AWC998'][AWC_EACCESS];

} elseif(count_games($userdata['user_id']) < AW_MAX_GAMES) {
	$plr_grp = $awc_settings['player_group'];
	$query = "SELECT user_id, user_name"
		." FROM ".DB_PREFIX."users"
		." WHERE";
	// aha, group
	if($plr_grp < 101) {
		$query .= " user_groups REGEXP('^\\\.{$plr_grp}$|\\\.{$plr_grp}\\\.|\\\.{$plr_grp}$')";
	// user, level
	} else {
		$query .= " user_level>='$plr_grp'";
	}
	$query .= " OR user_level='103'"	// superadmin
		." ORDER BY user_name ASC";
	$query_id = dbquery($query);

	$u_ops = "";
	while($user = dbarray($query_id)) {
		$u_ops .= "<option value='".$user['user_id']."'>"	
			.$user['user_name']."</option>";
	}

	echo "<form method='post' action='".FUSION_SELF."'>
<table class='tbl-border' cellspacing='1' align='center'>
<tr>
	<td class='tbl2' align='center' colspan='2'>"
		."<b>".$locale['AWC100'].": </b>"
		.count_games($userdata['user_id'])."/".AW_MAX_GAMES."</td>
</tr>
<tr>
	<td class='tbl2'>".$locale['AWC101'].":</td>
	<td class='tbl1'><select name='opp_id' class='textbox'>"
		."$u_ops</select> <input type='checkbox' name='aw_opp_white'>"
			.$locale['AWC006']."</td>
</tr>
<tr>
	<td class='tbl2'>".$locale['AWC002'].":</td>
	<td class='tbl1'><input type='checkbox' name='aw_is_public'>"
		.$locale['AWC102']."</td>
</tr>
<tr>
	<td class='tbl2'></td>
	<td class='tbl2'><input type='submit' name='invite' class='button'"
		." value='".$locale['AWC103']."'>
</td>
</tr>
</table>
</form>";

} else {
	echo "<p>".$locale['AWC998'][AWC_ENEWGAME];
}


closetable();

require_once(BASEDIR."side_right.php");
require_once(BASEDIR."footer.php");

?>
